#!/bin/bash

AQM="RED"	#AQM="DropTail RED SFQ DRR CHOKE CoDel"		# active queue management setting
TCC="ledbat"	  	#TCC="ledbat lp nice reno"			# low-priority congestion control type
WLD="9"	#WLD="0 1 2 3 4 5 6 7 8 9"		# workload 0 - 9 (represent 0.1 - 1.0)
BUF="100" 				#BUF="100 350"     				# buffer size (in packets)
CAP="4"				#CAP="10 1 0.5"					# link capacity (in MB)
RUN="08659 13721 23632 36896 47416 56731 60476 76466 85146 98409"					
#RUN="08659 13721 23632 36896 47416 56731 60476 76466 85146 98409"

TIME=60			# duration of simulation [seconds]
DELAY=0         # increment delay for hetero scenario
#TOT=10                 # TOTAL number of flows
#NUM="5" 		# number of low-priority flows
#SEED="13721 23632 18659 6896 27416 26731 10476 6466 5146 8409 9342 7735 30947 30799 7316 9469  "
#NUM="0 1 2 3 4 5 6 7 8 9 10" # number of low-priority flows

for aqm in $AQM; do
for tcc in $TCC; do
for wld in $WLD; do
	mkdir -p raw.$aqm.$tcc.$wld sum.$aqm.$tcc.$wld
	for buf in $BUF; do
	for cap in $CAP; do

    #Param Check if neccessary
	#GO=false
	#if [[ "$buf" == "100" && "$cap" == "10" ]]; then
	#GO=true
	#elif [[ "$buf" == "100" && "$cap" == "1" ]]; then
	#GO=true
	#elif [[ "$buf" == "350" && "$cap" == "0.5" ]]; then
	#GO=true
	#fi
    GO=true
	if [[ $GO == true ]]; then
		for run in $RUN; do

			tag="A$aqm.T$tcc.W$wld.B$buf.C$cap.R$run"
	
			if [ ! -e raw.$aqm.$tcc.$wld/log.$tag ]; 	# do not overwrite simulations
			#if true;	
			then
				echo "$tag ($SECONDS sec)"
				../bin/simulation-comp.tcl endtime $TIME inc_delay $DELAY \
					aqm $aqm tcp_type $tcc workload $wld buffer_size $buf capacity $cap seed $run \
					tag $tag > log.$tag

				#setupflows() 		#inc_delay 0 pacing 0
				#ledbat 			#base_histo_len 100 target 25 
				#currently no use	#do_tcp 0 tcp_interval 1200 tcp_slow_start 0 
				#nodes				#nodes_num $TOT nodes_low_prio 5
		
				#../bin/data-process.py -c $cap $tag* > $tag.STAT
				../bin/data-process.py -c $cap -t $TIME $tag.DATA > $tag.STAT

				# file arrangement
				mv *$tag* raw.$aqm.$tcc.$wld
				#gzip -fq raw.$aqm.$tcc.$wld/flow.$tag*
			else
				echo "$tag already generated"
			fi
	
		done
	 
		tag="A$aqm.T$tcc.W$wld.B$buf.C$cap"

		if [ ! -e sum.$aqm.$tcc.$wld/$tag.STAT ];
		then
			echo "[RUN] statistics generating..."
			../bin/stat-process.py -l r raw.$aqm.$tcc.$wld/$tag.*.STAT > $tag.STAT

			# file arrangement
			mv $tag.STAT sum.$aqm.$tcc.$wld/
		else
			echo "$tag.STAT already generated"
		fi

	fi
	done
	done

	tag="A$aqm.T$tcc.W$wld"

	if [ ! -e sum.$aqm.$tcc.$wld/$tag.STAT ];
	then
		echo "[BUF CAP] statistics generating..."
		../bin/stat-process.py -l c sum.$aqm.$tcc.$wld/$tag.*.STAT > $tag.STAT

		# file arrangement
		mv $tag.STAT sum.$aqm.$tcc.$wld/
	else
		echo "$tag.STAT already generated"
	fi

done

tag="A$aqm.T$tcc"

if [ ! -e $tag.STAT ];
then
	echo "[WLD] statistics generating..."
    ../bin/stat-process.py -l l -w "$WLD" sum.$aqm.$tcc.*/$tag.W?.STAT > $tag.STAT

	# file arrangement
	mv $tag.STAT sum.$aqm.$tcc.$wld/
else
	echo "$tag.STAT already generated"
fi

done
done
 
